import argparse
import random

from eapdataset import Dataset
from pathlib import Path

parser = argparse.ArgumentParser()
parser.add_argument("--dataset", type=str, required=True)
parser.add_argument("--predict_data", type=str, required=True)
parser.add_argument("--data", type=str, required=True)
parser.add_argument("--ratio", type=float, required=True)
args = parser.parse_args()

print(f"Fetching data from dataset {args.dataset} ...")
dataset = Dataset.get_by_name(args.dataset or 'predict-data')
df = dataset.to_pandas_dataframe(use_cached_result=False)
print("Fetched")

count = df.shape[0]

target_size = int(count * args.ratio)

final_df = df.iloc[target_size:, :]
index = random.randint(0, final_df.shape[0])
df = final_df.iloc[[index, index+1]]

acutal_df = df[['gen_active_pw', 'data_time_utc']]
Path(args.data).parent.mkdir(parents=True, exist_ok=True)
acutal_df.to_csv(args.data, index=False)

df = df.drop('data_time_utc', 1)
Path(args.predict_data).parent.mkdir(parents=True, exist_ok=True)
df.to_csv(args.predict_data, index=False)
